package com.example.datadump.service;

import com.example.datadump.util.FileUtils;
import com.taosdata.jdbc.TSDBDriver;
import org.springframework.stereotype.Service;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.List;
import java.util.Map;
import java.util.Properties;

@Service
public class ImportTDEngine {
    /**
     * TDEngine数据库恢复
     *
     * @param ip       IP地址
     * @param port     端口号
     * @param db       数据库
     * @param userName 用户名
     * @param passWord 密码
     * @param table    表名,如果多个表以逗号分隔
     * @param path     导出路径
     * @throws Exception
     */
    public void importTDEngine(String ip, String port, String db, String userName, String passWord, String table, String path) throws Exception {
        String jdbcUrl = "jdbc:TAOS://" + ip + ":" + port + "/" + db + "?user=" + userName + "&password=" + passWord;
        Properties connProps = new Properties();
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_CHARSET, "UTF-8");
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_LOCALE, "en_US.UTF-8");
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_TIME_ZONE, "UTC-8");
        Connection conn = DriverManager.getConnection(jdbcUrl, connProps);
        //--------------------------------------------------
        Statement ps;
        ps = conn.createStatement();
        //所有数据
        ResultSet rs = null;
        //转换过后的数据
        List<Map<String, String>> a;
        //---------创建文件----------
        String[] csvNames = table.split(",");
        //根据表名循环
        for (String tableName : csvNames) {
            String filePath = path + File.separator + tableName;
            //如果目录下没有这个表的文件,那么就是第一次执行,只有第一次执行的时候才会导出所有的数据
            File[] files = FileUtils.searchFile(new File(path), tableName);
            for (File file : files) {
                String sql = "insert into " + tableName + " file '" + file.getPath() + "';";
                rs = ps.executeQuery(sql);
            }

            //转换过后的数据
        }
        if (rs != null)
            rs.close();
        if (ps != null)
            ps.close();
        conn.close();
    }
}
