package com.example.datadump.service;

import com.example.datadump.util.DateTimeUtil;
import com.taosdata.jdbc.TSDBDriver;

import java.sql.*;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.*;

public class TDEngineService1 {

    public static void main(String[] args) throws Exception {
        //mysql
        Connection mysqlConn = null;
        ResultSet rs = null;
        String SQL = null;
        String url = "jdbc:mysql://" + "192.168.1.119" + ":" + "14000" + "/" + "jiayueCloud" + "?useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8&autoReconnect=true&rewriteBatchedStatements=true";
        //加载数据库驱动
        Class.forName("com.mysql.cj.jdbc.Driver");
        //创建连接
        mysqlConn = DriverManager.getConnection(url, "root", "M*R7Dp+H4ey2Y^319@");
        Statement statement = mysqlConn.createStatement();
        SQL = "SELECT \r\n" +
                "   *\r\n" +
                "FROM  stormbringer_wind_tower_info \r\n" +
                " where equipment_type = '1'";
        rs = statement.executeQuery(SQL);
        //所有声雷达
        List<String> eqList = new ArrayList<>();
        while (rs.next()) {
            eqList.add(rs.getString("equipment_no"));
        }
        eqList = eqList.subList(64, eqList.size());
        mysqlConn.close();
        rs.close();

        //tdengine
        String jdbcUrl = "jdbc:TAOS://" + "192.168.1.114" + ":" + "6030" + "/" + "jiayueCloud" + "?user=" + "root" + "&password=" + "123456";
        Properties connProps = new Properties();
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_CHARSET, "UTF-8");
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_LOCALE, "en_US.UTF-8");
        connProps.setProperty(TSDBDriver.PROPERTY_KEY_TIME_ZONE, "UTC-8");
        Connection conn = DriverManager.getConnection(jdbcUrl, connProps);
        Statement ps;
        ps = conn.createStatement();
        ResultSet tdengineRS = null;
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSXXX");
        //开始处理所有声雷达的所有表里的数据
        List<String> heightList = new ArrayList<>();
        for (int i = 10; i <= 200; i = i + 10) {
            heightList.add(String.valueOf(i));
        }
        for (String eq : eqList) {
            for (String height : heightList) {
                String firstSQL = "select first(ts) from anemometry_" + eq + "_" + height;
                String lastSQL = "select last(ts) from anemometry_" + eq + "_" + height;
                tdengineRS = ps.executeQuery(firstSQL);
                List<Map<String, String>> firstList = convertList(tdengineRS);
                //获取第一条数据的开始时间
                Date firstDate = format.parse(firstList.get(0).get("first(ts)"));
                tdengineRS = ps.executeQuery(lastSQL);
                List<Map<String, String>> endList = convertList(tdengineRS);
                //获取最后一条数据的结束时间
                Date lastDate = format.parse(endList.get(0).get("last(ts)"));
                for (long i = firstDate.getTime(); i < lastDate.getTime(); i += 1000 * 60 * 60 * 24L) {
                    Date date = DateTimeUtil.getDayLastTime1(i);
                    //获取23点59的数据
                    String sql = "select * from anemometry_" + eq + "_" + height + " where ts = '" + format1.format(date) + "'";
                    tdengineRS = ps.executeQuery(sql);
                    List<Map<String, String>> a = convertList(tdengineRS);
                    if (!a.isEmpty()) {
                        Date date1 = format1.parse(a.get(0).get("ts"));
                        String time1 = format1.format(new Date(date1.getTime() + 1000 * 60L));
                        //把23点59分的数据插入到第二天0点0分
                        String sql1 = "INSERT INTO anemometry_" + eq + "_" + height + " USING prophase_anemometry_data TAGS(" + eq + "," + height + ") VALUES('" + time1 + "'," + a.get(0).get("ws_inst") + "," + a.get(0).get("ws_max") + "," + a.get(0).get("ws_min") + "," + a.get(0).get("ws_ave") + "," + a.get(0).get("ws_gust") + "," + a.get(0).get("ws_sta") + "," + a.get(0).get("wd_inst") + "," + a.get(0).get("wd_max") + "," + a.get(0).get("wd_min") + "," + a.get(0).get("wd_ave") + "," + a.get(0).get("wd_sta") + "," + a.get(0).get("data_flag") + ")";
                        int update = ps.executeUpdate(sql1);
                        System.out.println("anemometry_" + eq + "_" + height + "表, 插入" + update + "条数据, 数据时间为: " + time1);
                    }
                }
                System.out.println("anemometry_" + eq + "_" + height + "表,结束");
            }
        }
    }

    private static List<Map<String, String>> convertList(ResultSet rs) throws Exception {
        List<Map<String, String>> list = new ArrayList<>();
        ResultSetMetaData md = rs.getMetaData();//获取键名
        int columnCount = md.getColumnCount();//获取行的数量
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSXXX");
        while (rs.next()) {
            Map<String, String> rowData = new LinkedHashMap<>();//声明Map
            for (int i = 1; i <= columnCount; i++) {
                if ("ts".equals(md.getColumnName(i))) {
                    //把2021-01-01 00:10:00.0 转换成 2021-01-01T08:00:00.000+08:00'
                    Date date = format.parse(rs.getString(i));
                    rowData.put(md.getColumnName(i), format1.format(date));
                } else {
                    rowData.put(md.getColumnName(i), rs.getString(i) == null ? "NULL" : rs.getString(i));//获取键名及值
                }
            }
            list.add(rowData);
        }
        return list;
    }
}
